/************************************************************************\
*									 *
*									 *
*    *****			*****					 *
*      *****		      *****					 *
*	 *****		    *****					 *
*	   *****	  *****						 *
*	     *****	*****		The Firmware.			 *
*	       *****  *****		The Net.			 *
*	     *****	*****		The Boxware.			 *
*	   *****	  *****		Software for Ham Radio.		 *
*	 *****		    *****	Portable. Compatible.		 *
*      *****		      *****	General Public Licensed.	 *
*    *****			*****	By NORD><LINK.			 *
*									 *
\************************************************************************/


#include "l7.h"
#include "l3v.c"

/*** Variable fuer Level 7                                                   */

HRDTYP	hrdlis[MAXHRD];		/* Heardliste				     */
char     *clipoi;               /* Pointer in CLI Zeile                      */
char     clilin[CLILEN];        /* Zeile fuer CLI                            */

MBHEAD *text[TEXTE];		/* Connect-, Info-, Disc- Aktuell-Text, usw. */
char    blklis[L2VLEN+1];	/* Black List (gesperrte Calls)		     */

unsigned sec;			/* Uhrzeit				     */
unsigned minute;
unsigned stunde;

char     usrcal[L2IDLEN];       /* Call des aktuellen Users                  */
char     ncall[L2IDLEN];        /* Call des Nachbarn                         */
char     ndigi[L2VLEN+1];       /* Digiliste zum Nachbarn                    */
char     nport;                 /* Port des Nachbarn                         */

unsigned clicnt;                /* Zaehler fuer Zeichen in CLI Zeile         */

unsigned nquali;                /* Qualitaet des Knotens                     */
unsigned tic10;                 /* RTC, 10ms Increment                       */
unsigned lastic;                /* Zeitpunkt des letzten Timerservice        */
unsigned tic1s;                 /* zaehlt Zeit bis 1s, wird dann rueckgesetzt*/
unsigned beatim;                /* Zeitzaehler fuer Bake, 1s Increment       */

LHEAD    usccpl;                /* Kopf der CCP-User Liste                   */
LHEAD    userhd;                /* Kopf der User Liste                       */
USRTYP   *userpo;               /* Pointer in User Liste                     */

PTCTYP   ptcrdl[NUMPAT];        /* Patchcord Liste                           */
PTCTYP   *ptcrdp;               /* Pointer in Patchcord Liste                */

/*****************************************************************************\

WW      WW     AA     RRRRRRRR   NN      NN UU      UU NN      NN   GGGGGG   
WW      WW   AA  AA   RR      RR NN      NN UU      UU NN      NN GG      GG
WW      WW AA      AA RR      RR NNNN    NN UU      UU NNNN    NN GG
WW      WW AA      AA RRRRRRRR   NN  NN  NN UU      UU NN  NN  NN GG
WW      WW AAAAAAAAAA RR  RR     NN    NNNN UU      UU NN    NNNN GG    GGGG
WW  WW  WW AA      AA RR    RR   NN      NN UU      UU NN      NN GG      GG
  WW  WW   AA      AA RR      RR NN      NN   UUUUUU   NN      NN   GGGGGGGG

============================================================================
============================================================================

Neue Variable muessen unbedingt vor magicn eingefuegt werden. Sonst kann es zu
Problemen beim Neustart kommen. Werden neue Variable hinter fremem angefuegt,
ist ein Programmabsturz vorprogrammiert. Dieses Modul muss wegen der Variablen
fremem unbedingt als letztes Modul geladen werden, das RAM-Speicher belegt.

\*****************************************************************************/

int      magicn;                /* Pruefziffer fuer Warm-Kalt-Start          */
char     stackb[STACKLEN-1];    /* Systemstack                               */
char	 stack;
unsigned     fremem;            /* Anfang des freien Speichers               */

/*** Ende l7v.c                                                            ***/
